.data?
Manipulador_barra_ferramentas	dd	?

.code

Crie_barra_de_ferramentas	proc	 MANIPULADOR_JANELA:DWORD,IMAGEM:DWORD,LARGURA:DWORD,ALTURA:DWORD,NUMERO_DE_BOTOES:DWORD,ID_DO_COMANDO:DWORD
;------------------[Cria uma barra de ferramentas com a IMAGEM fornecida, a LARGURA e a ALTURA do botes, ]--------------------
;------------------[o NUMERO_DE_BOTOES que  para inserir, e o ID_DO_COMANDO base que ser incrementado de um ,supondo estar em ordem crescente seu ID]--------------------
;------------------[as variveis locais desta rotina]--------------------
	LOCAL	botao_toolbar:TBBUTTON
	LOCAL	imagem_botao_toolbar:TBADDBITMAP
	LOCAL	tamanho_botao:DWORD
	LOCAL	Manipulador_figura_da_barra:DWORD
	LOCAL	manipula:DWORD
	LOCAL	retangulo:RECT
	mov	tamanho_botao,0
	mov eax,NUMERO_DE_BOTOES						;multiplicamos a largura de cada boto pelo nmero deles para saber a largura total
	mul LARGURA										;o resultado fica em eax, supondo apenas valores menores que um byte, apesar de ser DWORD
;------------------[criamos a barra de ferramentas]--------------------
	invoke CreateWindowEx, WS_EX_LEFT,addr Tool, addr Nome_Janela,WS_VISIBLE or WS_CHILD or CCS_TOP or CCS_ADJUSTABLE or TBSTYLE_REGISTERDROP or \
	CCS_NODIVIDER or TBSTYLE_TOOLTIPS or TBSTYLE_WRAPABLE or TBSTYLE_ALTDRAG,0,0,eax,ALTURA,MANIPULADOR_JANELA,NULO,Manipulador_Instancia,NULO
	mov Manipulador_barra_ferramentas, eax
;	invoke SendMessage,Manipulador_barra_ferramentas,TB_CUSTOMIZE,0,0
	invoke SendMessage,Manipulador_barra_ferramentas,TB_BUTTONSTRUCTSIZE, sizeof botao_toolbar,0	;Preenchemos o tamanho da estrutura do boto
;------------------[se a janela da toolbar foi criada por createwindowex ento esta mensagem dever ser enviada antes de ]--------------------
;------------------[enviar as mensagens TB_ADDBITMAP ou TB_ADDBUTTONS]--------------------
;------------------[pegamos o manipulador para os tipos(tag,hint) que cada um dos botes da barra de tarefas ter]--------------------
	INVOKE SendMessage,Manipulador_barra_ferramentas,TB_GETTOOLTIPS,0,0
	mov Manipulador_tipo,eax
;------------------[e setamos o seu tempo]--------------------
	invoke SendMessage,Manipulador_barra_ferramentas,TTM_SETDELAYTIME,TTDT_INITIAL,0		;setamos o tempo necessrio que o controle ir demorar at aparecer
	invoke SendMessage,Manipulador_barra_ferramentas,TTM_SETDELAYTIME,TTDT_RESHOW,0		;setamos o tempo subsequente em que a mudana de um controle para outro ir aparecer
	xor eax,eax
	mov ecx,LARGURA				;a largura de cada boto na barra de ferramentas
	mov eax,ALTURA				;a altura de cada boto na barra de ferramentas
	shl eax,16					;arredamos para a esquerda
	mov ax,cx					;encaixamos o da direita
	mov	tamanho_botao,eax		;altura e largura do boto
invoke SendMessage,Manipulador_barra_ferramentas,TB_SETBUTTONSIZE,0,tamanho_botao			;Configuramos o tamanho do boto

;------------------[A mensagem TB_SETBITMAPSIZE seta o tamanho da imagem do boto a ser adicionada para a barra de ferramentas.]--------------------
	invoke SendMessage,Manipulador_barra_ferramentas,TB_SETBITMAPSIZE,0,tamanho_botao	;setamos o tamanho do boto nesta barra de ferramentas
;------------------[carregamos a imagem que ir compor a barra de ferramentas]--------------------
	invoke LoadBitmap, Manipulador_Instancia,IMAGEM	;BARRA_FERRAMENTAS
	;invoke Preencher_cor_defundo_dafigura,eax									;preenchemos o fundo da imagem com a cor especfica
	mov Manipulador_figura_da_barra,eax
	mov eax,0	;ze for zero, ento  pq existe uma imagem 
	mov imagem_botao_toolbar.hInst,eax
	push Manipulador_figura_da_barra	;esta imagem ser o identificador dos botes
	pop imagem_botao_toolbar.nID

;------------------[adicionamos os botes com sua respectiva imagem]--------------------
;------------------[adicionar uma ou mais imagens para a lista de imagens de botes avaliados para a barra de ferramentas]--------------------
	invoke SendMessage,Manipulador_barra_ferramentas,TB_ADDBITMAP,NUMERO_DE_BOTOES,addr imagem_botao_toolbar
	
;------------------[a estrutura do boto  ento preenchida]--------------------
	mov botao_toolbar.fsState,   TBSTATE_ENABLED 	;or TBSTATE_WRAP ;isto com enable para barras laterais	;estado do boto
	mov botao_toolbar.dwData,    0
	mov botao_toolbar.iString,   0		;string do boto
	mov botao_toolbar.iBitmap,   0		;ndice baseado na imagem para o boto
;------------------[Identificador do comando associado com o boto. Este identificador  usado numa mensagem WM_COMMAND]--------------------
;------------------[quando o boto  escolhido. Se o membro do estilo fsStyle  um valor TBSTYLE_SEP, este membro dever ser zero.]--------------------
	mov botao_toolbar.idCommand, 0		;O IDENTIFICADOR em uma mensagem WM_COMMAND
;	mov botao_toolbar.fsStyle,   TBSTYLE_SEP
;------------------[adicionamos primeiro o separador]--------------------
;	invoke SendMessage,Manipulador_barra_ferramentas,TB_ADDBUTTONS,1,ADDR botao_toolbar	;adicionamos um separador antes de todos os botes desta barra
	mov botao_toolbar.fsStyle,   TBSTYLE_BUTTON	;TBSTYLE_GROUP or TBSTYLE_CHECKGROUP

;------------------[adicionamos os botes com seus respectivos IDENTIFICADORES setados igualmente com a lista fornecida]--------------------

	xor ecx,ecx					;zeramos o contador para o ndice
	.while ecx < NUMERO_DE_BOTOES
		push ecx
		push eax
		mov botao_toolbar.iBitmap, ecx			;ndice da figura
		mov eax,ID_DO_COMANDO					;ser o identificador do boto na mensagem WM_NOTIFY
		mov botao_toolbar.idCommand, eax		;atrelada a mensagem de comando
		mov botao_toolbar.iString,   offset editor		;string do boto
		invoke SendMessage,Manipulador_barra_ferramentas,TB_ADDBUTTONS,1,ADDR botao_toolbar	;OK
		inc ID_DO_COMANDO
		pop eax
		pop ecx
		inc ecx
	.endw
ret

Crie_barra_de_ferramentas endp
